class BlueprintWrapperController{
    constructor() {
        this.mainWrapper = null
        this.backdrop = null
        this.blueprintItems = []

        this.selectors = {
            mainWrapperSelector: '#main-wrapper',
            backdropSelector: '#blueprintWrapperBackdrop',
            itemSelector: '.dzm-blueprint-item'
        }

    }

    init(){
        console.log('Hello from',this.constructor.name)

        // ARE THERE ANY BLUEPRINT ITEMS?
        this.blueprintItems = document.querySelectorAll(this.selectors.itemSelector)
        if(this.blueprintItems == null || this.blueprintItems.length <= 0){
            console.log(this.constructor.name,'No BlueprintWrapperItems found')
            return
        }

        // IS THERE A MAINWRAPPER
        this.mainWrapper = document.querySelector(this.selectors.mainWrapperSelector)
        if(this.mainWrapper == null){
            console.log(this.constructor.name, 'No Mainwrapper')
            return;
        }

        // CREATE BACKDROP
        this.backdrop = document.createElement('div');
        this.backdrop.classList.add('bluePrintBackdrop');
        this.backdrop.id = 'blueprintWrapperBackdrop'
        this.mainWrapper.appendChild(this.backdrop);

        // HANDLE FUNCTIONS
        this.blueprintItems.forEach(item=>{
            item.addEventListener('mouseenter',()=>this.handleMouseEnter())
            item.addEventListener('mouseleave',()=>{
                this.backdrop.style.opacity = '0'
            })
        })

    }

    handleMouseEnter(){
        this.backdrop.style.opacity = '1'
    }
}



document.addEventListener('DOMContentLoaded',()=>{
    (new BlueprintWrapperController()).init()
})